#include "proto.h"
#include "audio.h"

char fn[32];

extern unsigned int cd_sector;
extern unsigned int cd_offset;
extern unsigned int cd_ndat;

int doit_mp3(int loc, int len, char *name)
{
	int i;
	char a;
	//cd_seek(loc);
	cd_sector=loc>>11;
	cd_offset=0;
	cd_ndat=0;
	byte_count=len;
	lcd_puts(0,"- Playing -");
	lcd_puts(1,name);
	
	i=mp3_main();
	audio_stop(i);
	lcd_puts(2," ");
	
	return i;
}

#define MAXLIST 4096
int nmp3;
struct {
	int lba;
	int len;
	char name[64];
}mp3_list[MAXLIST];

int doit_list(int loc, int len, char *name)
{
	int i;
	if ((int)strstr(name,".MP3")!=0 || (int)strstr(name,".mp3")!=0){
		mp3_list[nmp3].lba=loc;
		mp3_list[nmp3].len=len;
		strncpy(mp3_list[nmp3].name,name,64);
		if (nmp3<MAXLIST) nmp3++;
	}
	
	return 0;
}

/*---------------------------------------------------------------------------
	mode:	0: directory, sequential,	1: recursive, sequential
		2: directory, random,		3: recursive, random
---------------------------------------------------------------------------*/
unsigned int random_time=0;

void play_list(int lba,int mode)
{
	int i,j,t;
	unsigned short ix[MAXLIST];
	
	nmp3=0;
	lcd_puts(0,"-Making List-");
	lcd_puts(1," ");
	
	dir_alldir(lba,mode&1,doit_list);
	for (i=0;i<nmp3;i++) ix[i]=i;
	
	if (mode&2) {
		lcd_puts(0,"-Randomizing-");
		srand(random_time);
		for (i=0;i<nmp3;i++) {
			j=rand()%nmp3;
			t=ix[i];
			ix[i]=ix[j];
			ix[j]=t;
		}
	}

	for (i=0;i<nmp3;i++) {
		j=doit_mp3(mp3_list[ix[i]].lba,mp3_list[ix[i]].len,
			     mp3_list[ix[i]].name);
		switch(j) {
		case LEFT:	return;
		case UP:	if (i>0) i-=2; else i-=1; break;
		}
	}
}

void dir_navigate(int desp)
{
	int rl,fnl,flags,loc,len,dirlen,rdesp;
	int i,nf;
	
ini:
	cd_seek(desp+10);	/* Leemos tamao de directorio */
	dirlen=cd_get32();
	
	nf=2;
	rdesp=desp;
	for (;;) {
		for(i=0,rdesp=desp;i<nf;i++) {
			cd_seek(rdesp);
			rl=cd_getchar();	/* Record Len */
			if (rl==0) break;
			rdesp+=rl;
			cd_seek(rdesp);
			if (!cd_getchar()) {	/* Saltamos relleno de sector */
				rdesp=(rdesp+2048)&(~2047);
				if (rdesp-desp >= dirlen) break;
			}
		}
		if (i<nf) {nf=i; continue;}
		cd_seek(rdesp);
		rl=cd_getchar();	/* Record Len */
		cd_getchar();
		loc=cd_get32();		/* File Location */
		cd_get32();
		len=cd_get32();		/* File Len */
		cd_seek(rdesp+25);
		flags=cd_getchar();	/* Flags */
		cd_seek(rdesp+32);
		fnl=cd_getchar();	/* File Name Len */
		if (flags&2) lcd_puts(0,"Directory");
		else lcd_puts(0,"File");
		for (i=0;i<fnl;i++) fn[i]=cd_getchar();
		fn[i]=0;
		lcd_puts(1,fn);

		while ((i=lcd_view_buttons())==0){
			random_time++;
			if (gdrom_get_status()>5) return; //Cambio de disco
		}
		switch(i) {
		case UP:	if (nf>2) nf--; break;
		case DOWN:	nf++;	break;
		case LEFT:	cd_seek(desp);
				rdesp=desp+cd_getchar();
				cd_seek(rdesp+2);	/* Directorio padre */
				desp=cd_get32()<<11;
				goto ini;
		case RIGHT:	if (flags&2) {
					desp=loc<<11;
					goto ini;
				}else {
					doit_mp3(loc<<11,len,fn);
				}
				break;
		case DIR:	play_list(desp,0); break;
		case NESTED:	play_list(desp,1); break;
		case DIRR:	play_list(desp,2); break;
		case NESTEDR:	play_list(desp,3); break;
		case REBOOT:	//(*(void(**)())0x8c0000e0)(1);
				(*(void(**)())0x80000000)();
		}
	}
}

int dir_alldir(int desp,int modo,int (*doit)(int,int,char *))	/* modo==1 => recursivo */
{
	int i,rl,fnl,flags,loc,len,dirlen,rdesp;
	
	cd_seek(desp+10);	/* Leemos tamao de directorio */
	dirlen=cd_get32();

	rdesp=desp;		/* Saltamos directorio actual y padre */
	cd_seek(rdesp);
	rl=cd_getchar(); rdesp+=rl;
	cd_seek(rdesp);
	rl=cd_getchar(); rdesp+=rl;

	for (;;) {
		cd_seek(rdesp);
		rl=cd_getchar();	/* Record Len */
		if (rl==0) {
			rdesp=(rdesp+2048)&(~2047);
			if (rdesp-desp >= dirlen) break;
		}
		cd_seek(rdesp);
		rl=cd_getchar();	/* Record Len */
		if (rl==0) break;
		cd_getchar();
		loc=cd_get32();		/* File Location */
		cd_get32();
		len=cd_get32();		/* File Len */
		cd_seek(rdesp+25);
		flags=cd_getchar();	/* Flags */
		cd_seek(rdesp+32);
		fnl=cd_getchar();	/* File Name Len */

		//if (flags&2) lcd_puts(0,"Directory");
		//else lcd_puts(0,"File");
		for (i=0;i<fnl;i++) fn[i]=cd_getchar();
		fn[i]=0;
		if (flags&2) lcd_puts(1,fn);

		if ((flags&2) && modo) {
			if (dir_alldir(loc<<11,modo,doit)) return -1;
		}

		if (!(flags&2)) {
			if (doit(loc<<11,len,fn)) return -1;
		}
		rdesp+=rl;
	}
	return 0;
}
