
/* Variables globales */
const unsigned char font[]=
#include "font8x16.hex"

unsigned int bg_color,fg_color;

void wrchar(int x, int y, unsigned char a)
{
	volatile unsigned int *pin=(int *)0x85000000;
	unsigned int i,j;
	unsigned char chl,*pf;
	
	if (x<0 || x>39) return;
	if (y<0 || y>29) return;

	pf=(unsigned char *)font;
	pf+=((unsigned int)a)<<4;

	pin=&pin[y*16*640+x*16];

	for (i=0;i<16;i++) {
		chl=*pf++;
		for (j=0;j<8;j++) {
			if(chl&0x80) {*pin++=fg_color; *pin++=fg_color;}
			else pin=&pin[2];
			chl<<=1;
		}
		pin=&pin[640-16];
	}
}

int pv_x=0,pv_y=0;

void scr_putch(char a)
{
	int *ps,*pd;
	int i;

	switch(a) {
	case '\n':	pv_x=0;
			pv_y++;
			break;
	case '\r':	pv_x=0;
			break;
	case '\t':	pv_x+=4;
			pv_x&=~3;
			break;
	case 127:
	case 8:		if (pv_x>0) pv_x--;
			wrchar(pv_x,pv_y,' ');
			break;
	default:	wrchar(pv_x,pv_y,a);
			pv_x++;
			break;
	}
	if (pv_x>39) {
		pv_x=0;
		pv_y++;
	}
	if (pv_y>29) {	//*****scroll*****
		pv_y=29;
		pd=(int *)0x85000000;
		ps=&pd[640*16];
		for (i=640*(480-16);i;i--) *pd++=*ps++;
		for (i=640*16;i;i--) *pd++=bg_color;
	}
}

void gotoxy(short x,short y)
{
	pv_x=x; pv_y=y;
}

void cls()
{
	volatile unsigned int *pin=(unsigned int *)0x85000000;
	int i;
	
	for (i=640*480;i;i--) *pin++=bg_color;
	pv_x=pv_y=0;
}


/**************************** Funciones Grficas ******************************/
/* Funcin maestra */

inline void putpixel(int x,int y,int color) {
        volatile unsigned int *pin=(unsigned int *)0x85000000;
        pin[y*640+x]=color&0xffffff;
}

/********************************************/

void line (int comienzax,int comienzay,int finx,int finy,int color)
{
	int t,distancia;
	int xerr=0,yerr=0,delta_x,delta_y;
	int incx,incy;
	delta_x=finx-comienzax;
	delta_y=finy-comienzay;

	if (delta_x>0) incx=1;
	else if (delta_x==0) incx=0;
	else incx=-1;

	if (delta_y>0) incy=1;
	else if (delta_y==0) incy=0;
	else incy=-1;

	delta_x=abs(delta_x);
	delta_y=abs(delta_y);
	if (delta_x>delta_y) distancia =delta_x;
	else distancia=delta_y;

	for (t=0;t<distancia+1;t++) {
		putpixel(comienzax,comienzay,color);
		xerr+=delta_x;
		yerr+=delta_y;
		if (xerr>distancia) {
			xerr-=distancia;
			comienzax+=incx;
		}
		if (yerr>distancia) {
			yerr-=distancia;
			comienzay+=incy;
		}
	}
}

/*--------------------- Lneas horizontales aceleradas ----------------------*/
/*---------------- Se intentan escribir los pixels de 8 en 8 ----------------*/

inline void hline(int x0,int x1, int y, int color)
{
	volatile unsigned int *pin=(unsigned int *)0x85000000;
	int i;
	
	if (x0<0) x0=0; if (x0>639) x0=639;
	if (x1<0) x1=0; if (x1>639) x1=639;
	if (y<0) y=0; if (y>479) y=479;
	
	pin=&pin[640*y+x0];
	for (i=x1-x0;i;i--) *pin++=color;
}

/*---------------------- Lineas Verticales Aceleradas ------------------------*/

inline void vline(int x,int y0,int y1,int color)
{
	volatile unsigned int *pin=(unsigned int *)0x85000000;
	int i;

	pin=&pin[640*y0+x];
	for (i=y1-y0;i;i--) {
		*pin=color;
		pin=&pin[640];
	}
}

/*----------------------------------------------------------------------------*/

void punto_circulo(int x,int y,int centrox,int centroy,int color)
{
	putpixel(centrox+x,centroy+y,color);
	putpixel(centrox-x,centroy+y,color);
	putpixel(centrox+x,centroy-y,color);
	putpixel(centrox-x,centroy-y,color);
	
	putpixel(centrox+y,centroy+x,color);
	putpixel(centrox-y,centroy+x,color);
	putpixel(centrox+y,centroy-x,color);
	putpixel(centrox-y,centroy-x,color);
}

void punto_fcirculo(int x,int y,int centrox,int centroy,int color)
{
	hline(centrox-x,centrox+x,centroy+y,color);
	hline(centrox-x,centrox+x,centroy-y,color);
	
	hline(centrox-y,centrox+y,centroy+x,color);
	hline(centrox-y,centrox+y,centroy-x,color);
}

void circle (int centrox,int centroy,int radio,int color)
{
	int x,y,delta;

	y=radio;
	delta=3-(radio<<1);
	for (x=0;x<y;) {
		punto_circulo(x,y,centrox,centroy,color);
		if (delta<0)
			delta+=(x<<2)+6;
		else {
			delta+=(((x-y)<<2)+10);
			y--;
		}
		x++;
	}
	x=y;
	if (y) punto_circulo(x,y,centrox,centroy,color);
}

void filled_circle (int centrox,int centroy,int radio,int color)
{
	int x,y,delta;

	y=radio;
	delta=3-(radio<<1);
	for (x=0;x<y;) {
		punto_fcirculo(x,y,centrox,centroy,color);
		if (delta<0)
			delta+=(x<<2)+6;
		else {
			delta+=(((x-y)<<2)+10);
			y--;
		}
		x++;
	}
	x=y;
	if (y) punto_fcirculo(x,y,centrox,centroy,color);
}

void rectangle(int x0,int y0, int x1, int y1, int color)
{
	int i;

	hline(x0,x1,y0,color);
	hline(x0,x1,y1,color);
	vline(x0,y0,y1,color);
	vline(x1,y0,y1,color);
}

void filled_rectangle(int x0,int y0, int x1, int y1, int color)
{
	int i,j;
	
	for (i=y0;i<=y1;i++) {
		//for (j=x0;j<=x1;j++) putpixel(j,i,color);
		hline(x0,x1,i,color);
	}
}

