#include "scif.h"
#include "proto.h"
#include "video.h"
#include "graph.h"
#include "maple.h"

#define BG 0x00007f	//Dark blue
extern void pretty();

const unsigned char loader_code[]=
#include "loader.hex"

int controller;

void lcd_init()
{
	volatile int del;
	int i;
	
	//scif_init(115200);
	scif_init(9600);

        init_video();

	fg_color=0xffffff;	//White
	bg_color=BG;		//Dark blue
	cls();
	pretty();
	
	for (del=0;del<1000000;del++);
	scif_puts("\033[2J\033[H");
	
	controller=~find_controller();	
}

int lcd_view_buttons()
{
	int i=0;
	static first;
	static volatile int del=0;

        if (controller) {
	        for(;del;del--);
		i=read_controller();
	        if (i) {
	        	if (first) del=5000000; else del=2000000;
	        	first=0;
		} else first=1;
	
		if (i&0x010) return UP;
		if (i&0x020) return DOWN;
		if (i&0x040) return LEFT;
		if (i&0x080) return RIGHT;
		if (i&0x004) return DIR;
		if (i&0x002) return DIRR;
		if (i&0x400) return NESTED;
		if (i&0x200) return NESTEDR;
		if (i&0x008) return REBOOT;
	}
	
	if (scif_rec_check()) {
		while (scif_rec_check()){			
			i=scif_rec();
			switch(i) {
			case UP:
			case DOWN:
			case LEFT:
			case RIGHT:
			case DIR:
			case DIRR:
			case NESTED:
			case NESTEDR:
			case REBOOT:	return i;
			case 0x1c:	memcpy(0x8cfff800,loader_code,sizeof(loader_code));
					(*(void(*)())0x8cfff800)();
			}
		}
	}

	return 0;
}

void lcd_puts(int line, char *st)
{
	int i,l,len;
	char *p;

	filled_rectangle(2,(LCDPOS+1+(line<<1))*16,638,
			(LCDPOS+1+(line<<1))*16+15,BG+16);
	l=len=strlen(st); if (len>38) len=38;
	i=20-(len>>1);
	p=st;
	for (;len;len--) wrchar(i++,LCDPOS+1+(line<<1),*p++);

	if (line>1) return;	
	if (!line) scif_puts("\033[H\033[K");
	else scif_puts("\033[H\n\033[K");
	if(l>20) l=20;
	i=10-(l>>1);
	for(;i;i--) scif_send(' ');
	scif_puts(st);
}

