#define CD_STREAM
#include "proto.h"
#include "gdrom.h"

extern void _start();
extern int last_sect;

#define LNSECT 3
#define NSECT (1<<LNSECT)
int block=-1;	/* bloque del disco */
int offset=0;	/* Desplazamiento dentro del sector */
unsigned char datos[2048*NSECT];

int read_lba(unsigned char *buf, int sector, int nsector)
{
        int i,j;
        i=last_sect-(block*NSECT)-150;
        if(i>nsector) i=nsector; if (i<0) i=0;

        if (i>0) {
	        if (gdrom_read_sectors(buf,sector+150,i)<0) {
        	        _start();
        	}
        }
        for (;i<nsector;i++) {
        	for(j=0;j<2048;j++) buf[i*2048+j]=0;
        }
        return 0;
}

void cd_flush()
{
	offset=2048;
}

unsigned char cd_getchar()
{
	unsigned char ret;

	if (offset==2048*NSECT){
		offset=0;
		block++;
		read_lba(datos, block*NSECT, NSECT);
	}
	return datos[offset++];
}

unsigned int cd_get16()
{
	unsigned int a,b;
	a=cd_getchar();
	b=cd_getchar();
	return (b<<8) | a;
}

unsigned int cd_get32()
{
	unsigned int a,b,c,d;
	a=cd_getchar();
	b=cd_getchar();
	c=cd_getchar();
	d=cd_getchar();
	return (d<<24) | (c<<16) | (b<<8) | a;
}

unsigned int cd_get32BE()
{
	unsigned int a,b,c,d;
	a=cd_getchar();
	b=cd_getchar();
	c=cd_getchar();
	d=cd_getchar();
	return (a<<24) | (b<<16) | (c<<8) | d;
}

void cd_seek(int desp)
{
	int blk;
	
	blk=desp>>(11+LNSECT);
	offset=desp&(2048*NSECT-1);
	if (blk!=block) {
		block=blk;
		read_lba(datos, block*NSECT,NSECT);
	}
}

void cd_rseek(int desp)
{
	int seek;
	
	seek=(block<<(11+LNSECT)) | offset;
	seek+=desp;
	cd_seek(seek);
}

int byte_count;
/*
int cd_fread(char *dest,int n)
{
	int i;
	if (n>byte_count) n=byte_count;
	for (i=0;i<n;i++) *dest++=cd_getchar();
	byte_count-=n;
	return n;
}
*/
#define NSECTMP3 8
unsigned int cd_sector=0;
unsigned int cd_offset=0;
unsigned int cd_ndat=0;
unsigned char cd_buf[2048*NSECTMP3];

int disk_fread(int *dest,int n)
{
        int i,j;

        for (i=0;i<n;i++) {
        	if (byte_count>0) {
	                if (cd_offset==cd_ndat){
	                	j=last_sect-cd_sector-150;
	                	if (j>NSECTMP3) j=NSECTMP3; if (j<0) j=0;
        	                if (gdrom_read_sectors(cd_buf,cd_sector+150, j)<0)
        	                	_start();
                	        cd_sector+=j;
	                       	cd_offset=0;
	                       	cd_ndat=j*2048;
        	        }
                	*dest++=cd_buf[cd_offset++];
                	byte_count--;
         	} else *dest++=0;
        }
        return n;
}
